const fs = require('fs')
const path = require('path')

test('Given_Openings_When_NotTheSameDataInFile_Then_WrongOpeningsWillBeLoaded', () => {
    const openings = {
        "white": [
            {
                "title": "ruy lopez exemple",
                "folder": "spanish opening",
                "pgn": "1. e4 e5 2. Nf3 Nc6 3. Bb5 a6 4. Ba4 Nf6 5. O-O Be7 6. Re1 b5 7. Bb3 O-O 8. c3 d5 9. exd5 Nxd5 10. Nxe5 Nxe5 11. Rxe5 c6 12. d4 Bd6 13. Re1 Qh4 14. g3"
            },
            {
                "title": "simple opening",
                "folder": "spanish opening",
                "pgn": "1. e4 e5 2. Nf3 Nc6 3. Bb5"
            }
        ],
        "black": [
            {
                "title": "sicilian defense exemple",
                "folder": "random black opening",
                "pgn": "1. e4 c5 2. Nf3 d6 3. d4 cxd4 4. Nxd4 Nf6 5. Nc3 a6 6. Bg5 e6 7. f4 Be7 8. Qf3 Qc7 9. O-O-O Nbd7"
            },
            {
                "title": "random opening",
                "folder": "random black opening",
                "pgn": "1. e4 e5 2. Nf3 Nc6 3. Bb5"
            }
        ]
    }
    const filePath = path.resolve(__dirname, '../openings.json')
    const rawdata = fs.readFileSync(filePath)
    const json = JSON.parse(rawdata)
    expect(json).toEqual(openings)
})

